<?php

/*
=========================================================
 This Extension is intended for use with ExpressionEngine.
 ExpressionEngine is Copyright (c) 2003 pMachine, Inc.
 http://www.pmachine.com/
=========================================================
 THIS IS COPYRIGHTED SOFTWARE
 All RIGHTS RESERVED
 Written by: Derek Jones
 Copyright (c) 2006 Koru Productions
 http://ee.koruproductions.com/
--------------------------------------------------------
 Please do not distribute this extension without written
 consent from the author.
========================================================
Files:	ext.filter_by_author.php
		lang.filter_by_author.php
--------------------------------------------------------
 Purpose: 	Adds ability to filter by author in the
			Edit section of the control panel.
========================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}

class Filter_by_author
{
	var $settings = array();
	var $name = 'Filter By Author';
	var $version = '1.0';
	var $description = 'Adds ability to filter by author in Edit section of the control panel';
	var $settings_exist = 'n';
	var $docs_url = 'http://ee.koruproductions.com/filter_by_author/';
	
	// CONSTRUCTOR
	
	function Filter_by_author($settings='')
	{
	}
	
	function add_author_drop_down($s)
	{	
		global $DB, $DSP, $EXT, $IN, $LANG;
		
		if ($EXT->last_call !== FALSE)
		{
			$s = $EXT->last_call;
		}
		
		$LANG->fetch_language_file('filter_by_author');
		
		$member_id = $IN->GBL('author', 'GP');
		$cat_select = '<select name=\'cat_id\' class=\'select\' >';
		
		$auth_select  = $DSP->input_select_header('author').
						$DSP->input_select_option('', $LANG->line('filter_by_author'));
		$auth_select .= $DSP->input_select_option('all', 'All', ($member_id == 'all') ? 'y' : '');

		$sql = "SELECT member_id, screen_name from exp_members WHERE total_entries > 0 ORDER BY screen_name ASC";
		
		$query = $DB->query($sql);

		foreach ($query->result as $row)
		{
			$auth_select .= $DSP->input_select_option($row['member_id'], $row['screen_name'], ($member_id == $row['member_id']) ? 'y' : '');
		}
		
		$auth_select .= $DSP->input_select_footer().
						$DSP->nbs(2);
		
		
		$s = preg_replace ('/'.$cat_select.'/', $auth_select."\n".$cat_select , $s);
		
		$s .= <<<JINXIE
		<script type="text/javascript" charset="utf-8">
			window.onload = function()
			{
				fbaLoad();
				fbaAddEvents();
			}
			
			function fbaLoad()
			{
				if (document.getElementById('target').addEventListener)
				{
					document.getElementById('target').addEventListener('DOMSubtreeModified', fbaAddEvents, false);
				}
				else if (document.getElementById('target').attachEvent)
				{
					document.getElementById('target').attachEvent('DOMSubtreeModified', fbaAddEvents);
				}				
			}

			function fbaAddEvents()
			{
				var links = document.getElementsByTagName('a');

				for (i = 0; i < links.length; i++)
				{
					if (links[i].addEventListener)
					{
					  links[i].addEventListener('click', doLinkChange, false); 
					}
					else if (links[i].attachEvent)
					{
					  links[i].attachEvent('onclick', doLinkChange);
					}
				}
			}
			
			function doLinkChange(e)
			{
				author_id = document.getElementById("filterform").author.value;

				// IE sees the 'this' object as the window instead of the target element
				// so we works around it.
				
				var theTarget = e.target ? e.target : e.srcElement;
				
				if( theTarget && ( theTarget.nodeType == 3 || theTarget.nodeType == 4 ) ) {
				  theTarget = theTarget.parentNode;
				}
				if (theTarget.href)
				{
					theTarget.href = theTarget.href.replace(/M=view_entries&/, 'M=view_entries&author='+author_id+'&');					
				}
			}

		</script>

JINXIE;

		return $s;
	}
	
	function constrain_by_author()
	{
		global $IN;
		
		$member_id = $IN->GBL('author', 'GP');
		
		if ($member_id != '' && is_numeric($member_id))
		{
			return " AND exp_members.member_id = '$member_id'";
		}
	}
	
	function activate_extension()
	{
		global $DB;
		
		$DB->query($DB->insert_string('exp_extensions',
				array(
				'extension_id'	=> '',
				'class'			=> "Filter_by_author",
				'method'		=> "add_author_drop_down",
				'hook'			=> "edit_entries_search_form",
				'settings'		=> "",
				'priority'		=> 1,
				'version'		=> $this->version,
				'enabled'		=> "y"
				)
			)
		);
		
		$DB->query($DB->insert_string('exp_extensions',
				array(
				'extension_id'	=> '',
				'class'			=> "Filter_by_author",
				'method'		=> "constrain_by_author",
				'hook'			=> "edit_entries_search_where",
				'settings'		=> "",
				'priority'		=> 1,
				'version'		=> $this->version,
				'enabled'		=> "y"
				)
			)
		);
	}
		
	function disable_extension()
	{
		global $DB;
		
		$DB->query("DELETE FROM exp_extensions WHERE class = 'Filter_by_author'");
		
	}
	
}
?>